<?php


namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;

use Teknisa\Libs\Util\Environment;

class CadConsumidorDados {

	protected $entityManager;
	protected $util;
	protected $cadconsumidordadosFactory;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util, 
	Factories\CadConsumidorDadosFactory $cadconsumidordadosFactory)  {
		$this->entityManager 	          = $entityManager;
		$this->util                       = $util;
		$this->cadconsumidordadosFactory  = $cadconsumidordadosFactory;
	}

	public function findConsResp($params) {
		$CDCONSUMIDOR = $params[0]['value'];
		$CDCLIENTE    = $params[1]['value'];

		$params = array(
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':CDCLIENTE'    => $CDCLIENTE
		);

		$standarts = $this->cadconsumidordadosFactory->findConsResp($params);
		return $standarts;
	}
	
	public function saveConsResp ($params) {
		
		$paramethers = array(
			':NRCPFRESPCON' => $params[0]['NRCPFRESPCON'],
			':NMRESPCONS' 	=> $params[0]['NMRESPCONS'],
			':NRRGCONSUMID' => $params[0]['NRRGCONSUMID'],
			':CDCONSUMIDOR' => $params[0]['CDCONSUMIDOR'],
			':CDCLIENTE' 	=> $params[0]['CDCLIENTE'],
			':NMLOGINCONS'  => $params[0]['NMLOGINCONS'],
			':CDCARTAOMIFARE' => $params[0]['CDCARTAOMIFARE']
		);
		$this->cadconsumidordadosFactory->saveConsResp($paramethers);
	}
	
	public function changePasswordConsResp ($params) {
		$CDCLIENTE        = $params[0]["CDCLIENTE"];
		$CDCONSUMIDOR     = $params[0]["CDCONSUMIDOR"];
        $NMLOGINCONS      = $params[0]["NMLOGINCONS"];
        $CDSENHASITE      = $params[0]["newPassword"];
        $message = "";
        
		$paramethers = array(
			':CDCLIENTE'   => $CDCLIENTE,
			':CDCONSUMIDOR'=> $CDCONSUMIDOR,
			':NMLOGINCONS' => $NMLOGINCONS
		);

        /*Updates the consumer's password with the new password.*/
        $CDSENHASITE = $this->util->encrypt($CDSENHASITE);
        $CDSENHACONSMD5 = $CDSENHASITE;
        
		$paramethers = array(
			':CDCLIENTE'   => $CDCLIENTE,
			':CDCONSUMIDOR'=> $CDCONSUMIDOR,
			':NMLOGINCONS' => $NMLOGINCONS,
			':CDSENHASITE' => $CDSENHASITE,
			':CDSENHACONSMD5' => $CDSENHACONSMD5
		);
		$this->cadconsumidordadosFactory->changePasswordConsResp($paramethers);
	}
	
	public function validCodigo($params) {
		$CDCARTAOMIFARE = $params[0]['CDCARTAOMIFARE'];
		$CDCLIENTE  	= $params[0]['CDCLIENTE'];
		$CDCONSUMIDOR	= $params[0]['CDCONSUMIDOR'];

		$params = array(
			':CDCARTAOMIFARE'	=> $CDCARTAOMIFARE,
			':CDCLIENTE'    	=> $CDCLIENTE,
			':CDCONSUMIDOR'		=> $CDCONSUMIDOR
		);

		$standarts = $this->cadconsumidordadosFactory->validCodigo($params);
		return $standarts;
	}

	
}