<?php

namespace Teknisa\MAN\Services;

class Layout {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function getProductsAndSubGroupsByColor($params) {
		$params = array (
			':NRORG'			=> $params['NRORG'], 
			':NRBUTTONAUX'		=> $params['NRBUTTON'], 
			':DTINIVIGENCIA'	=> $params['DTINIVIGENCIA'], 
			':NRPGCONFTAUX' 	=> $params['NRPGCONFTELA'], 
			':NRCONFTELA'		=> $params['NRCONFTELA'], 
			':CDLOJA'			=> $params['CDLOJA'], 
			':CDFILIAL' 		=> $params['CDFILIAL']
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUCTS_AND_SUBGROUPS_BY_GROUP, $params);
	}
	
	public function getCountSubGrupoGrupo($params) {
		
		$params = array (
			':NRORG'			=> $params['NRORG'], 
			':NRBUTTONAUX'		=> $params['NRBUTTON'], 
			':DTINIVIGENCIA'	=> $params['DTINIVIGENCIA'], 
			':NRPGCONFTAUX' 	=> $params['NRPGCONFTELA'], 
			':NRCONFTELA'		=> $params['NRCONFTELA'], 
			':CDFILIAL' 		=> $params['CDFILIAL']
		);

		return $this->entityManager->getConnection()->fetchAll(self::VERIFICA_SUBGRUPO_VAZIO_GRUPO, $params);
	}
	
	public function getCountProdutosGrupo($params) {
		
		$params = array (
			':NRORG'			=> $params['NRORG'], 
			':NRBUTTONAUX'		=> $params['NRBUTTON'], 
			':DTINIVIGENCIA'	=> $params['DTINIVIGENCIA'], 
			':NRPGCONFTAUX' 	=> $params['NRPGCONFTELA'], 
			':NRCONFTELA'		=> $params['NRCONFTELA'], 
			':CDFILIAL' 		=> $params['CDFILIAL']
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::VERIFICA_PRODUTOS_VAZIO_GRUPO, $params);
	}
	
	
	public function updateProductsAndSubGroupsColor ($params) {
		$params = array (
		    ':CDFILIAL' 		=> $params['CDFILIAL'],
	        ':NRCONFTELA'		=> $params['NRCONFTELA'],
	        ':IDTPBUTTON'		=> $params['IDTPBUTTON'],
	        ':NRBUTTON' 		=> $params['NRBUTTON'],
	        ':NRPGCONFTELA' 	=> $params['NRPGCONFTELA'],
	        ':IDTPBUTONAUX' 	=> $params['IDTPBUTONAUX'],
	        ':NRBUTTONAUX'		=> $params['NRBUTTONAUX'],
	        ':NRPGCONFTAUX' 	=> $params['NRPGCONFTAUX'],
	        ':IDTPBUTONAUX2'	=> $params['IDTPBUTONAUX2'],
	        ':NRBUTTONAUX2' 	=> $params['NRBUTTONAUX2'],
	        ':NRPGCONFTAUX2'	=> $params['NRPGCONFTAUX2'],
	        ':DTINIVIGENCIA'	=> $params['DTINIVIGENCIA'], 
	        ':NRORG'			=> $params['NRORG'],
			':NRCOLORTEXT'		=> $params['NRCOLORTEXT'],
			':NRCOLORBACK'		=> $params['NRCOLORBACK']
		);

		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PRODUCTS_SUBGROUPS_COLORS, $params);
	}

	public function updateCaixa ($NRCONFTELA, $CDFILICONFTE, $CDFILICAIXA, $CDCAIXA, $NRORG, $DTINIVIGENCIA, $CDLOJA) {
		$params = array (
			':CDFILIAL' =>  $CDFILICONFTE, 
			':NRCONFTELA' =>  $NRCONFTELA, 
			':DTINIVIGENCIA' =>  $DTINIVIGENCIA, 
			':CDFILICAIXA' =>  $CDFILICAIXA, 
			':CDCAIXA' =>  $CDCAIXA, 
			':NRORG' => $NRORG,
			':CDLOJA' => $CDLOJA
		);
		
		$this->entityManager->getConnection()->executeQuery(self::UPDATE_CAIXA, $params);
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_CAIXA_ASSOCIADO, $params);
	}
	
	public function deleteCaixa ($CDFILICAIXA, $CDCAIXA, $NRORG, $CDLOJA) {
	
		$params = array (
			':CDFILIAL' =>  $CDFILICAIXA,
			':CDCAIXA'	=>  $CDCAIXA, 
			':NRORG'	=>  $NRORG ,
			':CDLOJA'	=>	$CDLOJA	
		);
		
		return $this->entityManager->getConnection()->executeQuery(self::REMOVE_NRCONFTELA_CAIXA, $params);
	}
	
	public function verificaCaixa ($CDFILIAL, $CDFILICAIXA, $DTINIVIGENCIA, $CDCAIXA, $NRORG) {
		$params = array (
			':CDFILIAL' =>  $CDFILIAL, 
			':DTINIVIGENCIA' =>  $DTINIVIGENCIA, 
			':CDFILICAIXA' =>  $CDFILICAIXA,
			':CDCAIXA' =>  $CDCAIXA, 
			':NRORG' => $NRORG 
		);

		$return = $this->entityManager->getConnection()->fetchAssoc(self::GET_CAIXA_ASSOCIADO, $params);
		if(isset($return['TOTAL']) && $return['TOTAL'] == 0){
			return true;
		}else{
			return false;
		}
	}

	public function getProductPreview ($conditions) {
		$params = array(
			':NRCONFTELA'    => $conditions['NRCONFTELA'],
			':CDFILIAL'      => $conditions['CDFILIAL'],
			':CDGRUPO'       => $conditions['CDGRUPO'],
			':TCDGRUPO'      => $conditions['TCDGRUPO'],
			':NRORG'  		 => $conditions['NRORG']
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_PREVIEW_PRODUCT, $params);
	}

	public function getRecebimentosPreview ($conditions) {
		$params = array(
			':NRCONFTELA'    => $conditions['NRCONFTELA'],
			':CDFILIAL'      => $conditions['CDFILIAL'],
			':CDGRUPO'      => $conditions['CDGRUPO'],
			':TCDGRUPO'      => $conditions['TCDGRUPO'],
			':NRORG'  		 => $conditions['NRORG']
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_PREVIEW_RECEBIMENTOS, $params);
	}

	public function getGrupromocProdPreview ($conditions) {
		$params = array(
			':NRCONFTELA'    => $conditions['NRCONFTELA'],
			':CDFILIAL'      => $conditions['CDFILIAL'],
			':CDGRUPO'      => $conditions['CDGRUPO'],
			':TCDGRUPO'      => $conditions['TCDGRUPO'],
			':NRORG'  		 => $conditions['NRORG']
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_PREVIEW_GRUPROMOC, $params);
	}

	public function getProdCombPreview ($conditions) {
		$params = array(
			':NRCONFTELA'    => $conditions['NRCONFTELA'],
			':CDFILIAL'      => $conditions['CDFILIAL'],
			':CDGRUPO'      => $conditions['CDGRUPO'],
			':TCDGRUPO'      => $conditions['TCDGRUPO'],
			':NRORG'  		 => $conditions['NRORG']
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_PREVIEW_PRODPROMO, $params);
	}
	
	public function findPosicaoDisponivelBD ($params) {
		$qry = $this->entityManager->getConnection()->fetchAll(self::BUSCA_POSICOES_DISPONIVEIS, $params);
		return $qry;
	}
	
	public function findPosicaoDisponivelBDProduto ($params) {
		$qry = $this->entityManager->getConnection()->fetchAll(self::BUSCA_POSICOES_DISPONIVEIS_PRODUTO, $params);
		return $qry;
	}
	
	public function GetProdInterval($params){
		$return = $this->entityManager->getConnection()->fetchAll(self::ENCONTRA_INTERVALO_PRODUTOS_CONFTERMCAIXA, $params);
		return $return;
	}
	
	public function GetAllProd($params){
		$return = $this->entityManager->getConnection()->fetchAll(self::ENCONTRA_TODOS_PRODUTOS, $params);
		return $return;
	}
	
	public function encontraProximaPosicao($params, $response = null){
		$qry = array();
		if($params[':NRPGCONFTELA'] < 11){
			$posicoes = array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13",
	                  "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26",
	                  "27", "28", "29", "30", "31", "32", "33", "34", "35", "36");
	                 
	       
			$qry = $this->entityManager->getConnection()->fetchAll(self::ENCONTRA_PROXIMA_POSICAO_CONFTERMCAIXA_CADAUT, $params);
			if(count($qry) == 36){
				$params[':NRPGCONFTELA'] = $params[':NRPGCONFTELA'] + 1;
				$response = $this->encontraProximaPosicao($params, $response);
				
			}else{
				foreach ($qry as $position){
					$posicoes = array_diff($posicoes, $position); 
				}
				$posicoes = array_reverse($posicoes);
				$response = array( 'PGCONFTELA' => $params[':NRPGCONFTELA'],
		        				   'NRBUTTON'   => array_pop($posicoes));
		        				   }
		}
		return $response;
	}

	
	
	public function removeFilhos($row){
		$this->entityManager->getConnection()->beginTransaction();
		try{
			$params = array(
				':CDFILIAL'=> $row['CDFILIAL'],
				':CDLOJA'=>$row['CDLOJA'],
				':NRCONFTELA'=>$row['NRCONFTELA'],
				':NRORG'=>$row['NRORG']
			);
			$this->removeItMenuConfTe($params);
			$this->updateCaixaAoDeletarConfTela($params);
			$this->removeConfTela($params);
			$this->entityManager->getConnection()->commit();
		}catch(Exception $e){
			$this->entityManager->getConnection()->rollBack();
		}
	}
	
	private function removeConfTela($params){
		$this->entityManager->getConnection()->executeQuery(self::DELETE_CONFTELA, $params);
	}
	
	private function removeProdAmbiente($params){
		$this->entityManager->getConnection()->executeQuery(self::DELETE_PRODAMBIENTE, $params);
	}
	
	private function updateCaixaAoDeletarConfTela($params){
		$this->entityManager->getConnection()->executeQuery(self::UPDATE_CAIXA_AO_DELETAR, $params);
	}
	
	private function removeItMenuConfTe($params){
		$this->entityManager->getConnection()->executeQuery(self::DELETE_ITMENUCONFTE, $params);
	}
	
	public function getNovoCod ($params) {
		return $this->entityManager->getConnection()->fetchAll(self::GET_NOVO_CODIGO_CONFIGURACAO_CAIXA, $params);
	}
	
	public function insertNovaConfiguracao ($params) {
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_NOVA_CONFIGURACAO_CAIXA, $params);
	}
	
	public function insertItensNovaConfiguracao ($params) {
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_ITENS_NOVA_CONFIGURACAO_CAIXA, $params);
	}
	
	public function verificaGrupoVazio($params) {
		return $this->entityManager->getConnection()->fetchAll(self::VERIFICA_GRUPO_VAZIO, $params);
	}
	
	private function setParams ($row){
		$params = [];
		if(count($row)){
			foreach ($row as $key=>$value) {
				$params[':'.$key] = $value;
			}
		}
		return $params;
	}
	
	public function getProdutoFamilia ($row){
		$params = $this->setParams($row);
		if(isset($row['CDFILIAL']) && !empty($row['CDFILIAL'])){
			$adqParamVend = $this->returnValueQuery(self::ADQ_PARAVEND,$params);
			$adqFilial = $this->returnValueQuery(self::ADQ_FILIAL, $params);
			$adqParamFilial = $this->returnValueQuery(self::ADQ_PARAM_FILIAL, $params);
			return $this->setNameDataSource($adqParamVend,$adqFilial,$adqParamFilial);
		}
	}
	
	private function returnValueQuery ($query,$params){
		$return = $this->entityManager->getConnection()->fetchAll($query, $params);
		return count($return) ? $return[0] : [];
	}
	
	private function setNameDataSource($adqParamVend,$adqFilial,$adqParamFilial){
		$cdsegmer = (isset($adqFilial['CDSEGMER']) && !empty($adqFilial['CDSEGMER'])) ? $adqFilial['CDSEGMER'] : null;
		$string = '';
		if(isset($adqParamVend['CDGRPRODPDV']) && !is_null($adqParamVend['CDGRPRODPDV'])){
			if(!is_null($cdsegmer)){
				// Utiliza familia / segmento
				if(isset($adqParamFilial['IDUTMODPRODFIL']) && $adqParamFilial['IDUTMODPRODFIL'] == 'N'){
					$string = 'adqProdutoFamSeg1'; 
				}else{
					$string = 'adqProdutoFamSeg2';
				}
			}else{
				// Utiliza familia 
				if(isset($adqParamFilial['IDUTMODPRODFIL']) && $adqParamFilial['IDUTMODPRODFIL'] == 'N'){
					$string = 'adqProdutoFam1'; 
				}else{
					$string = 'adqProdutoFam2';
				}
			}
		}else{
			// Utiliza segmento
			if(!is_null($cdsegmer)){
				if(isset($adqParamFilial['IDUTMODPRODFIL']) && $adqParamFilial['IDUTMODPRODFIL'] == 'N'){
					$string = 'adqProdutoSeg1'; 
				}else{
					$string = 'adqProdutoSeg2';
				}
			}else{
				// Não Utiliza nada
				if(isset($adqParamFilial['IDUTMODPRODFIL']) && $adqParamFilial['IDUTMODPRODFIL'] == 'N'){
					$string = 'adqTodosProdutos1';
				}else{
					$string = 'adqTodosProdutos2';
				}
			}
		}
		return array('DATA_NAME'=>$string,'CDSEGMER'=>$cdsegmer);
	}
	
	public function verificaGrupoVazioSubGrupo($params){
			return $this->entityManager->getConnection()->fetchAll(self::VERIFICA_GRUPO_SUBGRUPO_VAZIO, $params);
	}
	
	public function verificaSubGrupoVazioProduto($params){
			return $this->entityManager->getConnection()->fetchAll(self::VERIFICA_SUBGRUPO_VAZIO, $params);
	}
	
	public function getIntervalProd($row){
		$params = array(
				':CDARVPRODINI'=> $row['CDARVPRODINI'],
				':CDARVPRODFINAL'=>$row['CDARVPRODFINAL'],
				':CDNVPRODUTO'=> $row['CDNVPRODUTO'],
				':CDFILIAL'=> $row['CDFILIAL'],
				':NRORG'=> $row['NRORG']
			);
		return $this->entityManager->getConnection()->fetchAll(self::GET_INTERVAL_PROD, $params);
	}
	
	public function	getIntervalProdNivel($row){
		$params = array(
				':CDARVPRODINI'=> str_pad($row['PRODNIV'], 12, "0"),
				':CDARVPRODFINAL'=>  str_pad($row['PRODNIV'], 12, "9"),
				':CDNVPRODUTO'=> $row['CDNVPRODUTO'],
				':CDFILIAL'=> $row['CDFILIAL'],
				':NRORG'=> $row['NRORG']
			);
		return $this->entityManager->getConnection()->fetchAll(self::GET_INTERVAL_PROD, $params);
	}
	
	public function getIntervalProdAll($row){
		$params = array(
				':CDNVPRODUTO'=> $row['CDNVPRODUTO']
			);
		return $this->entityManager->getConnection()->fetchAll(self::GET_INTERVAL_PROD_ALL, $params);
	}
	
	public function deletecascade($params){
		$this->entityManager->getConnection()->executeQuery(self::DELETECAS, $params);
	
	}
	
	public function deletecascadesub($params){
		$this->entityManager->getConnection()->executeQuery(self::DELETECASCADESUB, $params);
	}
	
	public function deletecascadetpReceb($params){
		try{
			$connection = $this->entityManager->getConnection();
		    $connection->beginTransaction();
			$this->entityManager->getConnection()->executeQuery(self::DELETETPRECEB, $params);
			$connection->commit();
			return true;
		}
		catch (\Exception $e) {
			$connection->rollBack();
			return true;
        }
	}
	
	public function DeleteProdSub($param){
		try{
			$connection = $this->entityManager->getConnection();
		    $connection->beginTransaction();
			$this->entityManager->getConnection()->executeQuery(self::DELETEPRODSUBGRUP, $param);
			$connection->commit();
		}
		catch (\Exception $e) {
            $connection->rollBack();
            throw $e; 
        }
	}
	
	public function VerificaSubGrupo($param){
		
		return $this->entityManager->getConnection()->fetchAll(self::SELECTSUBGRUPO, $param);
	}
	
	const DELETETPRECEB = "
	DELETE FROM ITMENUCONFTE
        WHERE
		   CDFILIAL   = :CDFILIAL 
		   AND NRCONFTELA   = :NRCONFTELA 
		   AND NRORG = :NRORG 
		   AND NRBUTTONAUX = :NRBUTTONAUX 
		   AND NRPGCONFTAUX = :NRPGCONFTAUX 
		   AND DTINIVIGENCIA = :DTINIVIGENCIA
		   AND IDTPBUTTON IN ('5','G','H')
		   AND IDTPBUTONAUX = '6' 
	";
	
	const DELETEPRODSUBGRUP = "
	
	DELETE FROM ITMENUCONFTE
				
	            WHERE
	           
			   CDFILIAL   = :CDFILIAL AND
	           
			   NRCONFTELA   = :NRCONFTELA AND
	           
	           NRORG = :NRORG AND
	          
	           IDTPBUTONAUX2 = '2' AND
	        
	           NRBUTTONAUX2 = :NRBUTTONAUX2 AND
	                              
	           DTINIVIGENCIA =:DTINIVIGENCIA
	           
			";
	
	
	const DELETECASCADESUB = "
	DELETE FROM ITMENUCONFTE
			WHERE
           
		   CDFILIAL   = :CDFILIAL AND
           
		   NRCONFTELA   = :NRCONFTELA AND
           
           NRORG = :NRORG AND
           
           NRBUTTONAUX = :NRBUTTONAUX AND
           
           NRPGCONFTAUX = :NRPGCONFTAUX AND
                      
           NRPGCONFTAUX2 = :NRPGCONFTAUX2 AND
           
           NRBUTTONAUX2 =:NRBUTTONAUX2 AND
           
           DTINIVIGENCIA =:DTINIVIGENCIA
           
				   
	";
	
	
	const DELETECAS = "
	DELETE FROM ITMENUCONFTE
	WHERE
	(CDFILIAL               = :CDFILIAL              ) AND
	(NRCONFTELA      = :NRCONFTELA      ) AND 
	(IDTPBUTTON       in ('1','9','A','I')      ) AND
	(IDTPBUTONAUX  = '2')  AND 
	(NRBUTTONAUX   = :NRBUTTONAUX  ) AND
	(NRPGCONFTAUX = :NRPGCONFTAUX) AND
	(DTINIVIGENCIA = :DTINIVIGENCIA)
					   
	";
		const SELECTSUBGRUPO = "
	SELECT * FROM ITMENUCONFTE
	WHERE
	(CDFILIAL               = :CDFILIAL              ) AND
	(NRCONFTELA      = :NRCONFTELA      ) AND 
	(IDTPBUTTON       in ('I')      ) AND
	(IDTPBUTONAUX  = '2')  AND 
	(NRBUTTONAUX   = :NRBUTTONAUX  ) AND
	(NRPGCONFTAUX = :NRPGCONFTAUX) AND
	(DTINIVIGENCIA = :DTINIVIGENCIA)
					   
	";
	
	public function changeGroup($row) {
		$params = array(
				':NEXTNRBUTTONAUX'=> $row['NEXTNRBUTTONAUX'],
				':NEXTPGAUX'=> $row['NEXTPGAUX'],
				':NEXTNRBUTTONSON'=> $row['NEXTNRBUTTONSON'],
				':NEXTPGSON'=> $row['NEXTPGSON'],
				':CDFILIAL' => $row['CDFILIAL'],
				':NRCONFTELA' => $row['NRCONFTELA'],
				':NRBUTTON' => $row['NRBUTTON'],
				':NRPGCONFTELA' => $row['NRPGCONFTELA'],
				':NRBUTTONAUX' => $row['NRBUTTONAUX'],
				':NRPGCONFTAUX' => $row['NRPGCONFTAUX'],
				':DTINIVIGENCIA' => $row['DTINIVIGENCIA'],
				':CDIDENTBUTON' => $row['CDIDENTBUTON']
			);
		return $this->entityManager->getConnection()->executeQuery(self::CHANGE_GROUP, $params);
	}
	
	public function getNextButton($row){
		$params = array(
				':NEXTNRCONFTELA' => $row['NEXTNRCONFTELA'],
				':CDFILIAL' => $row['CDFILIAL'],
				':NEXTNRBUTTONAUX'=> $row['NEXTNRBUTTONAUX'],
				':NEXTPGAUX'=> $row['NEXTPGAUX'],
				':NEXTPGSON'=> $row['NEXTPGSON']
			);
		return $this->entityManager->getConnection()->fetchAll(self::GET_NEXT_BUTTON, $params);
	}
	
	public function verificaPaginaEPosicaoProdutoSubGrupo($params, $paginaAntiga,$query) {
        $return = $this->entityManager->getConnection()->fetchAssoc($query, $params);
		
		if(isset($return['NRBUTTON'])) {
			if($return['NRBUTTON'] == $paginaAntiga) {
				return true;
			} else {
				return false;
			}
		} else {
			return true;
		}
    }
    
    public function insertProdutoSubGrupo($row) {
    	$params = array(
			':CDFILIAL'       => $row['CDFILIAL'], 
			':NRCONFTELA'     => $row['NRCONFTELA'], 
			':IDTPBUTTON'     => $row['IDTPBUTTON'], 
			':NRBUTTON'       => $row['NRBUTTON'], 
			':NRPGCONFTELA'   => $row['NRPGCONFTELA'], 
			':IDTPBUTONAUX'   => $row['IDTPBUTONAUX'],
		    ':NRBUTTONAUX'    => $row['NRBUTTONAUX'], 
		    ':NRPGCONFTAUX'   => $row['NRPGCONFTAUX'],
		    ':CDIDENTBUTON'   => $row['CDIDENTBUTON'],
		    ':DSBUTTON'       => $row['DSBUTTON'],
		    ':NRCOLORTEXT'    => $row['NRCOLORTEXT'],
		    ':NRCOLORBACK'    => $row['NRCOLORBACK'],
	        ':NRFONTETEXT'    => $row['NRFONTETEXT'],
	        ':DTINIVIGENCIA'  => $row['DTINIVIGENCIA'],
	        ':IDTPBUTONAUX2'  => $row['IDTPBUTONAUX2'],
	        ':NRBUTTONAUX2'   => $row['NRBUTTONAUX2'],
	        ':NRPGCONFTAUX2'  => $row['NRPGCONFTAUX2'],
	        ':CDOPERULTATU'   => $row['CDOPERULTATU'],
	        ':NRORGULTATU'    => $row['NRORGULTATU'],
	        ':CDOPERINCLUSAO' => $row['CDOPERINCLUSAO'],
	        ':NRORGINCLUSAO'  => $row['NRORGINCLUSAO'],
	        ':DTINCLUSAO'     => $row['DTINCLUSAO'], 
	        ':DTULTATU'       => $row['DTULTATU'],
	        ':IDEXIBEAPPCONS' => $row['IDEXIBEAPPCONS'],
	        ':NRORG'          => $row['NRORG'],
	        ':DSBUTTONESPANH' => $row['DSBUTTONESPANH'],
	        ':DSBUTTONINGLES' => $row['DSBUTTONINGLES'],
	        ':CDATAPRODITM'   => $row['CDATAPRODITM'],
	        ':DSENDEIMG'	  => $row['DSENDEIMG']
		);
			
    	return $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODUTO_SUBGRUPO, $params);
    }
    
    const INSERT_PRODUTO_SUBGRUPO = "
    	INSERT INTO ITMENUCONFTE
			  (CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX,
			   NRBUTTONAUX, NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK,
			   NRFONTETEXT, DTINIVIGENCIA, IDTPBUTONAUX2, NRBUTTONAUX2,
		       NRPGCONFTAUX2, CDOPERULTATU, NRORGULTATU, CDOPERINCLUSAO, NRORGINCLUSAO,
		       DTINCLUSAO, DTULTATU, IDEXIBEAPPCONS, NRORG, DSBUTTONESPANH, DSBUTTONINGLES, CDATAPRODITM,DSENDEIMG)
	    VALUES (:CDFILIAL, :NRCONFTELA, :IDTPBUTTON, :NRBUTTON, :NRPGCONFTELA, :IDTPBUTONAUX,
			    :NRBUTTONAUX, :NRPGCONFTAUX, :CDIDENTBUTON, :DSBUTTON, :NRCOLORTEXT, :NRCOLORBACK,
		        :NRFONTETEXT, :DTINIVIGENCIA, :IDTPBUTONAUX2, :NRBUTTONAUX2,
		        :NRPGCONFTAUX2, :CDOPERULTATU, :NRORGULTATU, :CDOPERINCLUSAO, :NRORGINCLUSAO,
		        :DTINCLUSAO, :DTULTATU, :IDEXIBEAPPCONS, :NRORG, :DSBUTTONESPANH, :DSBUTTONINGLES, :CDATAPRODITM,:DSENDEIMG)

    ";
	
    const VERIFICA_PAGINA_E_POSICAO_PRODUTO = "
        SELECT
            NRBUTTON
        FROM
            ITMENUCONFTE
        WHERE
            (CDFILIAL      = :CDFILIAL      ) AND
            (NRCONFTELA    = :NRCONFTELA    ) AND
            (DTINIVIGENCIA = :DTINIVIGENCIA ) AND
            (IDTPBUTTON    in ('1','9','A') ) AND
            (NRPGCONFTELA  = :NRPGCONFTELA  ) AND
            (NRPGCONFTAUX  = :NRPGCONFTAUX  ) AND
            (NRBUTTONAUX   = :NRBUTTONAUX   ) AND
            (IDTPBUTONAUX  = :IDTPBUTONAUX  ) AND
            (NRBUTTON      = :NRBUTTON      )
    ";
    const VERIFICA_PAGINA_E_POSICAO_PRODUTO_SUBGRUPO = "SELECT
		    NRBUTTON
		FROM
		    ITMENUCONFTE 
		    
		WHERE
		    ( CDFILIAL = :CDFILIAL )
		    AND ( NRCONFTELA = :NRCONFTELA )
		    AND NRORG = :NRORG
		    AND ( DTINIVIGENCIA = :DTINIVIGENCIA )
		    AND ( IDTPBUTTON IN (
		        '1',
		        '9',
		        'A'
		    ) )
		    AND ( NRPGCONFTELA = :NRPGCONFTELA )
		    AND ( NRPGCONFTAUX = :NRPGCONFTAUX )
		    AND ( NRBUTTONAUX = :NRBUTTONAUX )
		    AND ( IDTPBUTONAUX = :IDTPBUTONAUX )
		    AND ( NRBUTTON = :NRBUTTON )
		    AND IDTPBUTONAUX2 = '2'
		    AND NRBUTTONAUX2 = :NRBUTTONAUX2
		    AND NRPGCONFTAUX2 = :NRPGCONFTAUX2";
	
	const GET_CAIXA_ASSOCIADO = "
		SELECT COUNT(*) as total
		FROM CONFTELACAIXA 
		WHERE CDFILIAL = :CDFILIAL
		AND DTINIVIGENCIA = :DTINIVIGENCIA
		AND CDFILICAIXA = :CDFILICAIXA
		AND CDCAIXA = :CDCAIXA
		AND NRORG = :NRORG";
	
	const GET_NEXT_BUTTON = "
		SELECT (MAX(NRBUTTON)+1) AS NEXTBUTTON FROM ITMENUCONFTE
		WHERE NRCONFTELA = :NEXTNRCONFTELA
		AND CDFILIAL = :CDFILIAL
		AND IDTPBUTONAUX = '2'
		AND IDTPBUTTON ='1'
		AND NRBUTTONAUX = :NEXTNRBUTTONAUX
		AND NRPGCONFTAUX = :NEXTPGAUX
		AND NRPGCONFTELA = :NEXTPGSON
	";
	
	const CHANGE_GROUP = "
		UPDATE ITMENUCONFTE
		
		SET NRBUTTON = :NEXTNRBUTTONSON,
			NRPGCONFTELA = :NEXTPGSON,
			NRBUTTONAUX = :NEXTNRBUTTONAUX,
			NRPGCONFTAUX = :NEXTPGAUX,
			DTINIVIGENCIA = :DTINIVIGENCIA 
			
		WHERE CDFILIAL = :CDFILIAL 
		AND NRCONFTELA = :NRCONFTELA 
		AND NRBUTTON = :NRBUTTON 
		AND NRPGCONFTELA = :NRPGCONFTELA 
		AND IDTPBUTTON = '1'
		AND NRBUTTONAUX = :NRBUTTONAUX
		AND NRPGCONFTAUX = :NRPGCONFTAUX
		AND IDTPBUTONAUX = '2'
		AND CDIDENTBUTON = :CDIDENTBUTON
	";
	
	const GET_INTERVAL_PROD = "
		SELECT 
		  NRORG,
		  CDPRODUTO     AS CDPRODUTO,
		  CDARVPROD     AS CDARVPROD,
		  NMPRODUTO     AS DSBUTTON
		  FROM PRODUTO WHERE
		  CDNVPRODUTO = :CDNVPRODUTO
		  AND CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFINAL 
		  AND NRORG = :NRORG"
		;
		
	const GET_INTERVAL_PROD_ALL = "
		SELECT CDPRODUTO, CDARVPROD, NMPRODUTO AS DSBUTTON
		FROM PRODUTO 
		WHERE CDNVPRODUTO = :CDNVPRODUTO";
	
	const ADQ_PARAM_FILIAL = "
		SELECT IDBLPRCOMEST,
		NVL(IDUTMODPRODFIL, 'N') IDUTMODPRODFIL
		FROM PARAMFILIAL
		WHERE CDFILIAL = :CDFILIAL AND NRORG = :NRORG
	";
	
	const ADQ_FILIAL = "
		SELECT CDSEGMER
		FROM FILIAL
		WHERE CDFILIAL = :CDFILIAL
		AND NRORG      = :NRORG
		ORDER BY CDFILIAL
	";
	const ADQ_PARAVEND = "
		SELECT PV.CDGRPRODPDV
		FROM PARAVEND PV,
		  GRUPPROD GP
		WHERE (PV.CDFILIAL  = :CDFILIAL )
		AND (PV.NRORG       = :NRORG)
		AND (PV.CDGRPRODPDV = GP.CDGRUPPROD)
	";
	
	const DELETE_CONFTELA = "
		DELETE CONFTELA
			WHERE
		   CDFILIAL   = :CDFILIAL 
		   AND CDLOJA = :CDLOJA
		   AND NRCONFTELA = :NRCONFTELA
		   AND NRORG = :NRORG
	";
	
	const UPDATE_CAIXA_AO_DELETAR = "
		UPDATE CAIXA
			SET CDFILICONFTE = '',
			NRCONFTELA = ''
			WHERE CDFILICONFTE = :CDFILIAL
			AND NRCONFTELA = :NRCONFTELA
			AND NRORG = :NRORG
	";
	
	const DELETE_PRODAMBIENTE = "
		DELETE PRODAMBIENTE
		WHERE
		   CDFILIAL   = :CDFILIAL  
		   AND NRCONFTELA = :NRCONFTELA
		   AND NRORG = :NRORG
	";
	
	const DELETE_ITMENUCONFTE = "
		DELETE ITMENUCONFTE
		WHERE
		   CDFILIAL   = :CDFILIAL
		   AND NRCONFTELA = :NRCONFTELA
		   AND NRORG = :NRORG
	";
	
	const GET_NOVO_CODIGO_CONFIGURACAO_CAIXA = "
	      SELECT
	       M.NRCONFTELA, C.NMCONFTELA
	    FROM
	       (SELECT MAX(NRCONFTELA) AS NRCONFTELA
	        FROM   CONFTELA
	        WHERE  CDFILIAL = :P_CDFILIAL) M,
	        CONFTELA C
	    WHERE
	       (C.CDFILIAL   = :P_CDFILIAL ) AND
	       (M.NRCONFTELA = C.NRCONFTELA) AND
	       (C.NRORG      = :NRORG)
    ";
    
     const INSERT_NOVA_CONFIGURACAO_CAIXA = "
	    INSERT INTO CONFTELA
	  (CDFILIAL, CDLOJA, NRCONFTELA, NMCONFTELA, DSFUNDOTELA, DSLOGOTELA, IDESQUEMA, DTINIVIGENCIA)
	  (SELECT CDFILIAL, CDLOJA, :P_NRNOVO, :P_NMCONFTELA, DSFUNDOTELA, DSLOGOTELA, IDESQUEMA, :DTINIVIGENCIA
	   FROM   CONFTELA
	   WHERE  (CDFILIAL   = :P_CDFILIAL  ) AND
	          (NRCONFTELA = :P_NRCONFTELA) AND
	          (NRORG      = :NRORG))
    ";
    
    const INSERT_ITENS_NOVA_CONFIGURACAO_CAIXA = "
	  INSERT INTO ITMENUCONFTE
	  (CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX,
	   NRBUTTONAUX, NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK,
	   DSMESSAGEBUT, DSIMAGEMBUT, NRFONTETEXT, DTINIVIGENCIA)
	  (SELECT CDFILIAL, :P_NRNOVO, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX,
	          NRBUTTONAUX, NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK,
	          DSMESSAGEBUT, DSIMAGEMBUT, NRFONTETEXT, :DTINIVIGENCIA
	   FROM   ITMENUCONFTE
	   WHERE (CDFILIAL   = :P_CDFILIAL  )
	     AND (NRCONFTELA = :P_NRCONFTELA)
	     AND (NRORG      = :NRORG))
	  ";
  
	const INSERT_CAIXA_ASSOCIADO = "
		INSERT INTO CONFTELACAIXA
	        (CDFILIAL, NRCONFTELA, DTINIVIGENCIA, CDFILICAIXA, CDCAIXA, NRORG, DTULTATU, DTINCLUSAO)
	    VALUES
	        (:CDFILIAL, :NRCONFTELA, :DTINIVIGENCIA, :CDFILICAIXA, :CDCAIXA, :NRORG, SYSDATE, SYSDATE)
    ";
    
    const UPDATE_CAIXA = "
		UPDATE CAIXA 
			SET CDFILICONFTE = :CDFILIAL, 
				NRCONFTELA	 = :NRCONFTELA 
			WHERE CDFILIAL	 = :CDFILICAIXA  
				AND CDCAIXA  = :CDCAIXA
				AND NRORG	 = :NRORG
				AND CDLOJA	 = :CDLOJA
	";
	
	const REMOVE_NRCONFTELA_CAIXA = "
		UPDATE CAIXA 
			SET CDFILICONFTE = '', 
				NRCONFTELA	 = '' 
			WHERE CDFILIAL	 = :CDFILIAL  
				AND CDCAIXA  = :CDCAIXA
				AND NRORG	 = :NRORG
				AND CDLOJA	 = :CDLOJA
	";
    
    const BUSCA_POSICOES_DISPONIVEIS_PRODUTO = "
		SELECT DISTINCT I.NRBUTTON
		  FROM ITMENUCONFTE I
		 WHERE  I.CDFILIAL = :CDFILIAL
		   AND I.NRCONFTELA = :NRCONFTELA
		   AND I.NRBUTTONAUX = :NRBUTTONAUX
		   AND I.NRPGCONFTAUX = :NRPGCONFTAUX
		   AND I.IDTPBUTONAUX = :IDTPBUTONAUX
		   AND (IDTPBUTONAUX2 = :IDTPBUTONAUX2)
		   AND (NRBUTTONAUX2 = :NRBUTTONAUX2)
		   AND (NRPGCONFTAUX2 = :NRPGCONFTAUX2)
		   AND I.NRORG = :NRORG
		   AND I.NRPGCONFTELA = :NRPGCONFTELA
		   AND I.IDTPBUTTON IN ('1')
		 ORDER BY 1
	";
    
	const BUSCA_POSICOES_DISPONIVEIS = "
		SELECT DISTINCT I.NRBUTTON
		  FROM ITMENUCONFTE I
		 WHERE  I.CDFILIAL = :CDFILIAL
		   AND I.NRCONFTELA = :NRCONFTELA
		   AND I.NRBUTTONAUX = :NRBUTTONAUX
		   AND I.NRPGCONFTAUX = :NRPGCONFTAUX
		   AND I.IDTPBUTONAUX = :IDTPBUTONAUX
		   AND (IDTPBUTONAUX2 = :IDTPBUTONAUX2)
		   AND (NRBUTTONAUX2 = :NRBUTTONAUX2)
		   AND (NRPGCONFTAUX2 = :NRPGCONFTAUX2)
		   AND I.NRORG = :NRORG
		   AND I.NRPGCONFTELA = :NRPGCONFTELA
           AND I.IDTPBUTTON IN ('2', 'I', '7', '8', '9', 'A')
		 ORDER BY 1
	";
    
    const ENCONTRA_INTERVALO_PRODUTOS_CONFTERMCAIXA = "
		SELECT DISTINCT P.CDPRODUTO AS CDPRODUTO,
		  P.NMPRODUTO               AS DSBUTTON,
		  P.CDARVPROD               AS CDARVPROD
		FROM TABEVEND T,
		  ITEMPRECO I,
		  FILIAL F,
		  PRODUTO P,
		  TABEPREC TP
		LEFT JOIN FAMSALDOPROD FA
		ON (FA.CDFILIAL    = :CDFILIAL)
		AND (FA.NRORG      = :NRORG)
		WHERE (I.CDFILIAL  = :CDFILIAL )
		AND (I.NRORG       = :NRORG)
		AND (I.CDTABEPREC IN
		  (SELECT T.CDTABEPREC
		  FROM TABEVEND T
		  WHERE T.CDFILIAL                    = :CDFILIAL
		  AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
		  AND T.DTFINVGPREC                   > SYSDATE
		  GROUP BY CDTABEPREC
		  ))
		AND (SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC)
		AND (F.CDFILIAL    = T.CDFILIAL )
		AND (F.CDFILIAL    = I.CDFILIAL )
		AND (I.NRORG       = F.NRORG)
		AND (I.NRORG       = T.NRORG)
		AND (T.DTINIVGPREC = I.DTINIVGPREC )
		AND (I.NRORG       = P.NRORG)
		AND (I.CDPRODUTO   = P.CDPRODUTO )
		AND (T.CDTABEPREC  = I.CDTABEPREC )
		AND (I.NRORG       = TP.NRORG)
		AND (TP.CDFILIAL   = T.CDFILIAL )
		AND (TP.CDTABEPREC = T.CDTABEPREC )
		AND P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFINAL
		AND ((FA.CDFAMILISALD = :CDFAMILISALD) OR (:TCDFAMILISALD = 'T'))
		ORDER BY CDPRODUTO
		";
	const ENCONTRA_TODOS_PRODUTOS = "
	    SELECT DISTINCT I.CDFILIAL,
	    I.NRORG,
	    P.CDPRODUTO AS CDPRODUTO,
	    P.NMPRODUTO AS DSBUTTON,
	    P.CDARVPROD AS CDARVPROD
	  FROM TABEVEND T,
	    ITEMPRECO I,
	    FILIAL F,
	    PRODUTO P,
	    TABEPREC TP
	  WHERE (I.CDFILIAL  = :CDFILIAL )
	  AND (I.NRORG       = :NRORG)
	  AND (I.CDTABEPREC IN
	    (SELECT T.CDTABEPREC
	    FROM TABEVEND T
	    WHERE T.CDFILIAL                    = :CDFILIAL
	    AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
	    AND T.DTFINVGPREC                   > SYSDATE
	    GROUP BY CDTABEPREC
	    ))
	  AND (SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC)
	  AND (F.CDFILIAL    = T.CDFILIAL )
	  AND (F.CDFILIAL    = I.CDFILIAL )
	  AND (I.NRORG       = F.NRORG)
	  AND (I.NRORG       = T.NRORG)
	  AND (T.DTINIVGPREC = I.DTINIVGPREC )
	  AND (I.NRORG       = P.NRORG)
	  AND (I.CDPRODUTO   = P.CDPRODUTO )
	  AND (T.CDTABEPREC  = I.CDTABEPREC )
	  AND (I.NRORG       = TP.NRORG)
	  AND (TP.CDFILIAL   = T.CDFILIAL )
	  AND (TP.CDTABEPREC = T.CDTABEPREC )
	  ORDER BY CDPRODUTO
  ";
  
  const ENCONTRA_PROXIMA_POSICAO_CONFTERMCAIXA_CADAUT = "
		SELECT I.NRBUTTON , I.NRCONFTELA
  FROM ITMENUCONFTE I
  JOIN CONFTELA C
    ON (I.CDFILIAL     = C.CDFILIAL )
   AND (I.NRCONFTELA   = C.NRCONFTELA )
   AND I.DTINIVIGENCIA = C.DTINIVIGENCIA
 WHERE (I.CDFILIAL   = :CDFILIAL ) 
   AND (I.NRORG        = :NRORG)
   AND (I.IDTPBUTTON  IN ('1','9','A') )
   AND (C.CDLOJA       = :CDLOJA )
   AND I.NRCONFTELA    = :NRCONFTELA
   AND I.NRPGCONFTAUX  = :NRPGCONFTAUX
   AND I.NRBUTTONAUX   = :NRBUTTONAUX
   AND I.NRPGCONFTELA  = :NRPGCONFTELA
   AND I.DTINIVIGENCIA = :DTINIVIGENCIA
   ORDER BY 1
 ";
  
  const GET_PREVIEW_PRODUCT = "
  		SELECT B.* FROM (SELECT 
            (CASE 
               WHEN (IDTPBUTONAUX = '2') THEN NRPGCONFTAUX||NRBUTTONAUX   
               WHEN (IDTPBUTONAUX = 'I') THEN NRPGCONFTAUX||NRBUTTONAUX2 
            END) CDGRUPO,
           NRCOLORBACK AS COLOR, NRORG, IDTPBUTTON, IDTPBUTONAUX, NRBUTTON, NRBUTTONAUX, DSBUTTON, NMPRODUTO, CDIDENTBUTON, 
		   NRCOLORTEXT, NRCOLORBACK, NRPGCONFTELA, NRPGCONFTAUX, DSMESSAGEBUT, DSIMAGEMBUT, IDSOLLOCIMP, IDPESAPROD, CDARVPROD, CDPRODINTE, CDBARPRODUTO, IDTIPOPROD,
		   IDTIPOCOMPPROD, IDIMPPRODUTO, DTINIVGPROMOC, DTFINVGPROMOC, CDPRODUTO, IDCONTROLAREFIL, CDFILIAL, NRCONFTELA, DSENDEIMG, IDTPBUTONAUX2, NRBUTTONAUX2,
		   NRPGCONFTAUX2, DSPRODVENDA, 'N' AS IDPRODBLOQ, DSADICPROD, NRQTDMINOBS 
	  FROM ( SELECT AM.IDTPBUTTON, AM.IDTPBUTONAUX, AM.NRBUTTON, AM.NRBUTTONAUX, AM.DSBUTTON, AM.CDIDENTBUTON, AM.NRCOLORTEXT, AM.NRCOLORBACK, AM.NRPGCONFTELA, AM.NRPGCONFTAUX,
	  	 			AM.DSMESSAGEBUT, AM.DSIMAGEMBUT, PR.IDSOLLOCIMP, PR.IDPESAPROD, PR.CDARVPROD, PR.CDPRODINTE, PR.CDBARPRODUTO, PR.IDTIPOPROD, PR.IDTIPOCOMPPROD, PR.IDIMPPRODUTO,
	  	 			PR.DTINIVGPROMOC, PR.DTFINVGPROMOC, PR.CDPRODUTO, PR.IDCONTROLAREFIL, AM.CDFILIAL, AM.NRCONFTELA, NVL(AM.DSENDEIMG, PR.DSENDEIMG) AS DSENDEIMG, AM.IDTPBUTONAUX2,
	  	 			AM.NRBUTTONAUX2, AM.NRPGCONFTAUX2, PR.DSPRODVENDA, PR.DSADICPROD, PR.NRQTDMINOBS, AM.NRORG, PR.NMPRODUTO 
	  	 	   FROM ITMENUCONFTE AM 
	  	 	   JOIN PRODUTO PR 
	  	 		 ON AM.CDIDENTBUTON = PR.CDPRODUTO 
				AND AM.NRORG = PR.NRORG 
			   JOIN CONFTELA CF 
			   	 ON AM.CDFILIAL = CF.CDFILIAL 
			   	AND AM.NRCONFTELA = CF.NRCONFTELA 
			   	AND AM.NRORG = CF.NRORG 
			  WHERE AM.CDFILIAL = :CDFILIAL 
				AND AM.NRCONFTELA = :NRCONFTELA 
				AND AM.NRORG = :NRORG 
		   ) MESA 
	 WHERE IDTPBUTTON = '1' 
	   AND IDTPBUTONAUX IN ('2', 'I') 	   
	 ORDER BY NRPGCONFTAUX, NRBUTTONAUX, NRPGCONFTELA, NRBUTTON) B
     WHERE ((INSTR(:CDGRUPO, CDGRUPO) > 0) OR (:TCDGRUPO  = 'T'))
  ";
  
  const GET_PREVIEW_RECEBIMENTOS = "
		SELECT  I.NRPGCONFTAUX || I.NRBUTTONAUX AS CDGRUPO,  I.CDFILIAL,  I.NRCONFTELA,  I.NRPGCONFTELA, I.NRBUTTON, I.IDTPBUTTON, I.DSBUTTON,  I.CDIDENTBUTON, I.NRCOLORBACK, I.NRORG,
		        I.NRCOLORBACK AS COLOR
	      FROM  ITMENUCONFTE I
		 WHERE I.CDFILIAL = :CDFILIAL
		   AND I.IDTPBUTTON IN ( '5', 'G', 'H' )
		   AND I.NRCONFTELA = :NRCONFTELA
		   AND I.IDTPBUTONAUX = '6'
		   AND I.NRORG = :NRORG
		   AND ((INSTR(:CDGRUPO, I.NRPGCONFTAUX||I.NRBUTTONAUX) > 0) OR (:TCDGRUPO  = 'T'))
		 ORDER BY I.NRPGCONFTELA, I.NRBUTTON
  ";

  const GET_PREVIEW_GRUPROMOC = "
 	SELECT '0'||P.IDTIPOPROD AS CDCOMBO, NVL(I.CDIDENTBUTON, P.CDPRODUTO) AS CDIDENTBUTON,
           NVL(I.DSBUTTON, P.NMPRODUTO) AS DSBUTTON, P.CDPRODUTO, I.CDFILIAL,  I.NRCONFTELA,  
           I.NRPGCONFTELA, I.NRBUTTON, I.IDTPBUTTON, NVL(I.NRCOLORBACK, '11571344') AS NRCOLORBACK, P.NRORG,
           NVL(I.NRCOLORBACK, '11571344') AS COLOR
	  FROM PRODUTO P 
	  LEFT JOIN ITMENUCONFTE I
	    ON P.CDPRODUTO  = I.CDIDENTBUTON
	   AND I.NRORG 		= P.NRORG
	   AND I.CDFILIAL   = :CDFILIAL
	   AND I.NRCONFTELA = :NRCONFTELA
	   AND I.NRORG 		= :NRORG
	WHERE P.IDTIPOPROD IS NOT NULL
    AND ((INSTR(:CDGRUPO, '0'||P.IDTIPOPROD) > 0) OR (:TCDGRUPO  = 'T')) 
  ";

  const GET_PREVIEW_PRODPROMO = "
          SELECT DISTINCT PP.CDGRUPROMOC AS CDGRUPO, PP.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO AS DSBUTTON, P.IDIMPPRODUTO, '11571344' AS COLOR, P.NRORG
          FROM PRODUTO P 
          JOIN PRODGRUPROMOC PP
            ON P.CDPRODUTO = PP.CDPRODUTO
           AND P.NRORG = PP.NRORG
          JOIN GRUPROMOCPROD G
            ON PP.CDGRUPROMOC = G.CDGRUPROMOC
           AND PP.NRORG = G.NRORG
          LEFT JOIN GRUPROMOCPRFIL GF
            ON PP.CDGRUPROMOC = GF.CDGRUPROMOC
            AND PP.NRORG = GF.NRORG
            AND :CDFILIAL = GF.CDFILIAL
         WHERE ((INSTR(:CDGRUPO, PP.CDGRUPROMOC) > 0) OR ('T' = :TCDGRUPO))
            AND (TRUNC(SYSDATE) BETWEEN NVL(G.DTINIVGGRPROMO, TRUNC(SYSDATE)) AND NVL(G.DTFINVGGRPROMO,TRUNC(SYSDATE))) 
	        AND (TRUNC(SYSDATE) BETWEEN NVL(GF.DTINIVGGRPROFIL, TRUNC(SYSDATE)) AND NVL(GF.DTFINVGGRPROFIL, TRUNC(SYSDATE)))
            AND (G.CDPRODPROMOCAO IN (SELECT PR.CDPRODUTO
                               FROM ITMENUCONFTE AM 
                               JOIN PRODUTO PR 
                                 ON AM.CDIDENTBUTON = PR.CDPRODUTO 
                                AND AM.NRORG = PR.NRORG 
                               JOIN CONFTELA CF 
                                 ON AM.CDFILIAL = CF.CDFILIAL 
                                AND AM.NRCONFTELA = CF.NRCONFTELA 
                                AND AM.NRORG = CF.NRORG 
                              WHERE AM.CDFILIAL = :CDFILIAL 
                                AND AM.NRCONFTELA = :NRCONFTELA 
                                AND AM.NRORG = :NRORG 
                                AND AM.IDTPBUTTON = '1' 
                                AND AM.IDTPBUTONAUX IN ('2', 'I') 
                                AND PR.IDTIPOCOMPPROD = '3')
            OR GF.CDPRODPROMOCAO IN (SELECT PR.CDPRODUTO
                               FROM ITMENUCONFTE AM 
                               JOIN PRODUTO PR 
                                 ON AM.CDIDENTBUTON = PR.CDPRODUTO 
                                AND AM.NRORG = PR.NRORG 
                               JOIN CONFTELA CF 
                                 ON AM.CDFILIAL = CF.CDFILIAL 
                                AND AM.NRCONFTELA = CF.NRCONFTELA 
                                AND AM.NRORG = CF.NRORG 
                              WHERE AM.CDFILIAL = :CDFILIAL 
                                AND AM.NRCONFTELA = :NRCONFTELA 
                                AND AM.NRORG = :NRORG 
                                AND AM.IDTPBUTTON = '1' 
                                AND AM.IDTPBUTONAUX IN ('2', 'I') 
                                AND PR.IDTIPOCOMPPROD = '3'))
        
        ORDER BY PP.CDPRODUTO
  ";
  
   const VERIFICA_GRUPO_VAZIO = "
		SELECT
		    P.CDPRODUTO
		FROM
		    ITMENUCONFTE I,
		    CONFTELA C,
		    PRODUTO P,
		    NATPRODUTO N
		WHERE
		    ( I.CDFILIAL = :CDFILIAL )
		    AND   ( I.NRORG = :NRORG )
		    AND   ( I.IDTPBUTTON IN (
		        '1',
		        '9',
		        'A'
		    ) )
		    AND   ( I.CDFILIAL = C.CDFILIAL )
		    AND   ( I.NRCONFTELA = C.NRCONFTELA )
		    AND   ( C.CDLOJA = :CDLOJA )
		    AND   ( P.CDPRODUTO (+) = I.CDIDENTBUTON )
		    AND   ( N.CDNATPROD (+) = I.CDNATPRODUTO )
		    AND   I.NRCONFTELA = :NRCONFTELA
		    AND   I.NRPGCONFTAUX = :NRPGCONFTAUX
		    AND   I.NRBUTTONAUX = :NRBUTTONAUX
		    AND   I.IDTPBUTONAUX <> 'I' AND I.IDTPBUTONAUX2 = '0'
   ";
   
   
      const VERIFICA_GRUPO_SUBGRUPO_VAZIO = "
		SELECT
		    IT.NRPGCONFTELA || IT.NRBUTTON AS CDGRUPO,
		    IT.DSBUTTON,
		        CASE
		            WHEN IT.DSENDEIMG IS NULL THEN IT.DSENDEIMG
		            ELSE P.FILESERVERURL
		             || IT.DSENDEIMG
		        END
		    AS IMAGE,
		    IT.DSENDEIMG,
		    IT.NRCOLORBACK,
		    IT.NRPGCONFTELA,
		    IT.NRBUTTON,
		    IT.NRFONTETEXT,
		    IT.NRCOLORTEXT,
		    IT.NRCONFTELA,
		    IT.CDFILIAL,
		    IT.IDTPBUTTON,
		    IT.IDTPBUTONAUX,
		    IT.NRBUTTONAUX,
		    IT.NRPGCONFTAUX,
		    IT.NRORG,
		    IT.CDOPERULTATU,
		    IT.NRORGULTATU,
		    IT.CDOPERINCLUSAO,
		    IT.NRORGINCLUSAO,
		    IT.DTINCLUSAO,
		    IT.DTULTATU
		FROM
		    ITMENUCONFTE IT,
		    PARAMGERAL P
		WHERE
		        IT.IDTPBUTTON = 'I'
		    AND
		        IT.CDFILIAL =:CDFILIAL
		    AND
		        IT.NRCONFTELA =:NRCONFTELA
		    AND
		        IT.NRBUTTONAUX =:NRBUTTONAUX
		    AND
		        IT.NRPGCONFTAUX =:NRPGCONFTAUX
		    AND
		        IT.NRORG =:NRORG
		GROUP BY
		    IT.DSBUTTON,
		    IT.NRCOLORBACK,
		    IT.NRPGCONFTELA,
		    IT.NRBUTTON,
		    IT.NRCONFTELA,
		    IT.CDFILIAL,
		    IT.IDTPBUTTON,
		    IT.DSENDEIMG,
		    P.FILESERVERURL,
		    IT.IDTPBUTONAUX,
		    IT.NRFONTETEXT,
		    IT.NRBUTTONAUX,
		    IT.NRCOLORTEXT,
		    IT.NRPGCONFTAUX,
		    IT.NRORG,
		    IT.CDOPERULTATU,
		    IT.NRORGULTATU,
		    IT.CDOPERINCLUSAO,
		    IT.NRORGINCLUSAO,
		    IT.DTINCLUSAO,
		    IT.DTULTATU
		ORDER BY IT.NRPGCONFTELA || IT.NRBUTTON
   ";
   
   const VERIFICA_SUBGRUPO_VAZIO = "
		   SELECT /*+ USE_HASH(GR,P,O) ORDERED */
		    I.NRPGCONFTAUX,
		    I.DSBUTTONESPANH,
		    I.DSBUTTONINGLES,
		    I.CDATAPRODITM,
		    I.IDEXIBEAPPCONS,
		    I.NRPGCONFTELA || I.NRBUTTON AS CDGRUPO,
		    I.IDTPBUTONAUX2,
		    I.NRBUTTONAUX2,
		    I.NRFONTETEXT,
		    I.NRPGCONFTAUX2,
		    I.NRCONFTELA,
		    I.NRBUTTONAUX,
		    I.CDFILIAL,
		    I.NRBUTTON,
		    I.CDIDENTBUTON AS CDPRODUTO,
		    P.NMPRODUTO AS NMPRODUTO,
		    I.IDTPBUTONAUX,
		    I.NRPGCONFTELA,
		    I.DSENDEIMG,
		    I.DSBUTTON,
		    I.NRCOLORBACK,
		    I.NRCOLORTEXT,
		    I.CDIDENTBUTON,
		    I.IDTPBUTTON,
		        CASE
		            WHEN TRIM(I.DSENDEIMG) IS NULL THEN I.DSENDEIMG
		            ELSE P.FILESERVERURL
		             || I.DSENDEIMG
		        END
		    AS IMAGE,
		    P.CDARVPROD,
		    I.NRORG,
		    I.CDOPERULTATU,
		    I.NRORGULTATU,
		    I.CDOPERINCLUSAO,
		    I.NRORGINCLUSAO,
		    I.DTINCLUSAO,
		    I.DTULTATU
		FROM
		    ITMENUCONFTE I
		    INNER JOIN CONFTELA O ON
		        I.CDFILIAL = O.CDFILIAL
		    AND
		        I.NRCONFTELA = O.NRCONFTELA
		    INNER JOIN PRODUTO P ON I.CDIDENTBUTON = P.CDPRODUTO
		    CROSS JOIN PARAMGERAL P
		WHERE
		        I.CDFILIAL =:CDFILIAL
		    AND
		        I.NRCONFTELA =:NRCONFTELA
		    AND
		        I.IDTPBUTTON = '1'
		    AND
		        I.IDTPBUTONAUX = 'I'
		    AND
		        I.NRBUTTONAUX =:NRBUTTONAUX
		    AND
		        I.NRPGCONFTAUX =:NRPGCONFTAUX
		    AND
		        IDTPBUTONAUX2 = '2'
		    AND
		        NRBUTTONAUX2 =:NRBUTTONAUX2
		    AND
		        NRPGCONFTAUX2 =:NRPGCONFTAUX2
		    AND
		        I.NRORG =:NRORG
		GROUP BY
		    I.IDTPBUTONAUX2,
		    I.NRBUTTONAUX2,
		    P.FILESERVERURL,
		    I.NRPGCONFTAUX2,
		    I.CDFILIAL,
		    I.NRCONFTELA,
		    I.NRFONTETEXT,
		    I.IDTPBUTTON,
		    I.NRBUTTON,
		    I.CDIDENTBUTON,
		    I.DSBUTTON,
		    I.IDTPBUTONAUX,
		    I.NRPGCONFTELA,
		    I.NRPGCONFTAUX,
		    I.NRCOLORBACK,
		    I.NRCOLORTEXT,
		    I.DSENDEIMG,
		    I.DSBUTTONESPANH,
		    I.DSBUTTONINGLES,
		    I.CDATAPRODITM,
		    I.IDEXIBEAPPCONS,
		    P.CDARVPROD,
		    P.NMPRODUTO,
		    I.NRORG,
		    I.NRBUTTONAUX,
		    I.CDOPERULTATU,
		    I.NRORGULTATU,
		    I.CDOPERINCLUSAO,
		    I.NRORGINCLUSAO,
		    I.DTINCLUSAO,
		    I.DTULTATU
		ORDER BY
		    I.NRPGCONFTELA,
		    I.NRBUTTON
   ";
   
    const GET_PRODUCTS_AND_SUBGROUPS_BY_GROUP = "
		SELECT
		    I.CDFILIAL,
		    I.NRCONFTELA,
		    I.IDTPBUTTON,
		    I.NRBUTTON,
		    I.NRPGCONFTELA,
		    I.IDTPBUTONAUX,
		    I.NRBUTTONAUX,
		    I.NRPGCONFTAUX,
		    I.IDTPBUTONAUX2,
		    I.NRBUTTONAUX2,
		    I.NRPGCONFTAUX2,
		    I.DTINIVIGENCIA,
		    I.NRORG
		
		FROM
		    ITMENUCONFTE   I
		    INNER JOIN CONFTELA       O 
		            ON I.CDFILIAL = O.CDFILIAL
		           AND I.NRCONFTELA = O.NRCONFTELA
		    INNER JOIN PRODUTO        P 
		            ON I.CDIDENTBUTON = P.CDPRODUTO
		WHERE
		    I.CDFILIAL = :CDFILIAL
		    AND I.NRCONFTELA = :NRCONFTELA
		    AND I.IDTPBUTTON = '1'
		    AND I.IDTPBUTONAUX = 'I'
		    AND I.NRBUTTONAUX = :NRBUTTONAUX
		    AND I.NRPGCONFTAUX = :NRPGCONFTAUX
		    AND I.IDTPBUTONAUX2 = '2'
		    AND I.DTINIVIGENCIA = :DTINIVIGENCIA
		    AND I.NRORG = :NRORG
		GROUP BY
		    
		    I.CDFILIAL,
		    I.NRCONFTELA,
		    I.IDTPBUTTON,
		    I.NRBUTTON,
		    I.NRPGCONFTELA,
		    I.IDTPBUTONAUX,
		    I.NRBUTTONAUX,
		    I.NRPGCONFTAUX,
		    I.IDTPBUTONAUX2,
		    I.NRBUTTONAUX2,
		    I.NRPGCONFTAUX2,
		    I.DTINIVIGENCIA,
		    I.NRORG
		UNION
		SELECT
		    IT.CDFILIAL,
		    IT.NRCONFTELA,
		    IT.IDTPBUTTON,
		    IT.NRBUTTON,
		    IT.NRPGCONFTELA,
		    IT.IDTPBUTONAUX,
		    IT.NRBUTTONAUX,
		    IT.NRPGCONFTAUX,
		    IT.IDTPBUTONAUX2,
		    IT.NRBUTTONAUX2,
		    IT.NRPGCONFTAUX2,
		    IT.DTINIVIGENCIA,
		    IT.NRORG
		
		FROM
		    ITMENUCONFTE   IT
		WHERE
		    IT.IDTPBUTTON = 'I'
		    AND IT.CDFILIAL = :CDFILIAL
		    AND IT.NRCONFTELA = :NRCONFTELA
		    AND IT.NRBUTTONAUX = :NRBUTTONAUX
		    AND IT.NRPGCONFTAUX = :NRPGCONFTAUX
		    AND IT.DTINIVIGENCIA = :DTINIVIGENCIA
		    AND IT.NRORG = :NRORG
		GROUP BY
		    
		    IT.CDFILIAL,
		    IT.NRCONFTELA,
		    IT.IDTPBUTTON,
		    IT.NRBUTTON,
		    IT.NRPGCONFTELA,
		    IT.IDTPBUTONAUX,
		    IT.NRBUTTONAUX,
		    IT.NRPGCONFTAUX,
		    IT.IDTPBUTONAUX2,
		    IT.NRBUTTONAUX2,
		    IT.NRPGCONFTAUX2,
		    IT.DTINIVIGENCIA,
		    IT.NRORG
		UNION
		SELECT
		    I.CDFILIAL,
		    I.NRCONFTELA,
		    I.IDTPBUTTON,
		    I.NRBUTTON,
		    I.NRPGCONFTELA,
		    I.IDTPBUTONAUX,
		    I.NRBUTTONAUX,
		    I.NRPGCONFTAUX,
		    I.IDTPBUTONAUX2,
		    I.NRBUTTONAUX2,
		    I.NRPGCONFTAUX2,
		    I.DTINIVIGENCIA,
		    I.NRORG
		
		FROM
		    ITMENUCONFTE                                                                                                                          I
		    JOIN CONFTELA                                                                                                                              CO ON ( I.CDFILIAL = CO.CDFILIAL )
		                        AND ( I.NRCONFTELA = CO.NRCONFTELA )
		                        AND I.DTINIVIGENCIA = CO.DTINIVIGENCIA
		    JOIN FILIAL                                                                                                                                FI ON ( FI.CDFILIAL = CO.CDFILIAL )
		                      AND ( FI.NRORG = CO.NRORG )
		    LEFT JOIN PRODUTO                                                                                                                               P ON ( P.CDPRODUTO = I.CDIDENTBUTON )
		                           AND ( I.IDTPBUTTON IN (
		        '1',
		        '9',
		        'A'
		    ) )
		    LEFT JOIN NATPRODUTO                                                                                                                        PA ON ( PA.NRORG = I.NRORG )
		    JOIN (
		        SELECT
		            NRCONFTELA,
		            DSBUTTON,
		            NRBUTTON,
		            NRORG,
		            NRPGCONFTELA,
		            CDFILIAL,
		            DTINIVIGENCIA
		        FROM
		            ITMENUCONFTE IT
		        WHERE
		            ( IT.IDTPBUTTON IN (
		                '2',
		                '7',
		                '8'
		            ) )
		    ) ITMENU ON ITMENU.NRORG = I.NRORG
		                AND ITMENU.NRCONFTELA = I.NRCONFTELA
		                AND ITMENU.NRBUTTON = I.NRBUTTONAUX
		                AND ITMENU.NRPGCONFTELA = I.NRPGCONFTAUX
		                AND ITMENU.CDFILIAL = I.CDFILIAL
		                AND ITMENU.DTINIVIGENCIA = I.DTINIVIGENCIA
		WHERE
		    ( I.NRORG = :NRORG )
		    AND I.IDTPBUTONAUX = '2'
		    AND I.NRCONFTELA = :NRCONFTELA
		    AND I.NRPGCONFTAUX = :NRPGCONFTAUX
		    AND I.NRBUTTONAUX = :NRBUTTONAUX
		    AND CO.CDFILIAL = :CDFILIAL
		    AND CO.CDLOJA = :CDLOJA
		    AND P.CDPRODUTO IS NOT NULL
		    AND I.DTINIVIGENCIA = :DTINIVIGENCIA
   ";
   
   const UPDATE_PRODUCTS_SUBGROUPS_COLORS = "
		UPDATE ITMENUCONFTE
		   SET NRCOLORTEXT = :NRCOLORTEXT,
		       NRCOLORBACK = :NRCOLORBACK
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRCONFTELA = :NRCONFTELA
		   AND IDTPBUTTON = :IDTPBUTTON
		   AND NRBUTTON = :NRBUTTON
	       AND NRPGCONFTELA = :NRPGCONFTELA
	       AND IDTPBUTONAUX = :IDTPBUTONAUX
	       AND NRBUTTONAUX = :NRBUTTONAUX
	       AND NRPGCONFTAUX = :NRPGCONFTAUX
	       AND IDTPBUTONAUX2 = :IDTPBUTONAUX2
	       AND NRBUTTONAUX2 = :NRBUTTONAUX2
	       AND NRPGCONFTAUX2 = :NRPGCONFTAUX2
	       AND DTINIVIGENCIA = :DTINIVIGENCIA
	       AND NRORG = :NRORG
	";
	
	
	const VERIFICA_SUBGRUPO_VAZIO_GRUPO = "
			SELECT
			    COUNT(*) AS TOTAL
			FROM
			    ITMENUCONFTE   IT,
			    PARAMGERAL     P
			WHERE
			    IT.IDTPBUTTON = 'I'
			    AND IT.CDFILIAL = :CDFILIAL
			    AND IT.NRCONFTELA = :NRCONFTELA
			    AND IT.NRBUTTONAUX = :NRBUTTONAUX
			    AND IT.NRPGCONFTAUX = :NRPGCONFTAUX
			    AND IT.DTINIVIGENCIA = :DTINIVIGENCIA
			    AND IT.NRORG = :NRORG
			GROUP BY
			    IT.DSBUTTON,
			    IT.NRCOLORBACK,
			    IT.NRPGCONFTELA,
			    IT.NRBUTTON,
			    IT.NRCONFTELA,
			    IT.CDFILIAL,
			    IT.IDTPBUTTON,
			    IT.DSENDEIMG,
			    P.FILESERVERURL,
			    IT.IDTPBUTONAUX,
			    IT.NRFONTETEXT,
			    IT.NRBUTTONAUX,
			    IT.NRCOLORTEXT,
			    IT.NRPGCONFTAUX,
			    IT.NRORG,
			    IT.CDOPERULTATU,
			    IT.NRORGULTATU,
			    IT.CDOPERINCLUSAO,
			    IT.NRORGINCLUSAO,
			    IT.DTINCLUSAO,
			    IT.DTULTATU,
			    IT.DTINIVIGENCIA
			";
			
	const VERIFICA_PRODUTOS_VAZIO_GRUPO = "
			SELECT COUNT(*) AS TOTAL
			FROM
			    ITMENUCONFTE  I
			    JOIN CONFTELA  CO ON ( I.CDFILIAL = CO.CDFILIAL )
			                        AND ( I.NRCONFTELA = CO.NRCONFTELA )
			                        AND I.DTINIVIGENCIA = CO.DTINIVIGENCIA
			    JOIN FILIAL  FI ON ( FI.CDFILIAL = CO.CDFILIAL )
			                      AND ( FI.NRORG = CO.NRORG )
			    LEFT JOIN PRODUTO  P ON ( P.CDPRODUTO = I.CDIDENTBUTON ) AND ( I.IDTPBUTTON IN (
			        '1',
			        '9',
			        'A'
			    ) )
			    LEFT JOIN NATPRODUTO N ON ( N.CDNATPROD = I.CDNATPRODUTO )
			    JOIN PARAMGERAL PA ON ( PA.NRORG = I.NRORG )
			    JOIN (
			        SELECT
			            NRCONFTELA,
			            DSBUTTON,
			            NRBUTTON,
			            NRORG,
			            NRPGCONFTELA,
			            CDFILIAL,
			            DTINIVIGENCIA
			        FROM
			            ITMENUCONFTE IT
			        WHERE
			            ( IT.IDTPBUTTON IN (
			                '2',
			                '7',
			                '8'
			            ) )
			    ) ITMENU ON ITMENU.NRORG = I.NRORG
			                AND ITMENU.NRCONFTELA = I.NRCONFTELA
			                AND ITMENU.NRBUTTON = I.NRBUTTONAUX
			                AND ITMENU.NRPGCONFTELA = I.NRPGCONFTAUX
			                AND ITMENU.CDFILIAL = I.CDFILIAL
			                AND ITMENU.DTINIVIGENCIA = I.DTINIVIGENCIA
			WHERE
			    ( I.NRORG = :NRORG )
			    AND I.IDTPBUTONAUX = '2'
			    AND I.NRCONFTELA = :NRCONFTELA
			    AND I.NRPGCONFTAUX = :NRPGCONFTAUX
			    AND I.NRBUTTONAUX = :NRBUTTONAUX
			    AND CO.CDFILIAL = :CDFILIAL
			    AND P.CDPRODUTO IS NOT NULL
			    AND I.DTINIVIGENCIA = :DTINIVIGENCIA
			";
}